#!/bin/sh
#this is for hacks needed to fix a package, that might not have been done elsewhere.
#called from /usr/local/petget/installpkg.sh
#package that has just been installed is passed in on commandline.
#120924 DejaVu font no good for non-Latin languages. 120925 add korean.
#130122 xsane: remove warning about running as root.
#130221 pemasu: google-chrome run as root. 130224 pemasu: limit cache size.
#130326 pass in $DLPKG_NAME as $2. font size fix for 96 dpi.
#130507 kompozer needs MOZILLA_FIVE_HOME fix.

INSTALLEDPKG="$1" #ex: vlc_2.0.3-0ubuntu0.12.04.1_i386, without .deb
INSTALLEDNAME="$2" #130326

case $INSTALLEDPKG in
 vlc-nox_*)
  #120907 vlc in debian/ubuntu configured to not run as root (it is a pre-compile configure option to enable running as root).
  #this hack will fix it...
  #note, this code is also in FIXUPHACK in 'vlc' template.
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/bin/vlc  ];then
    bbe -e 's/geteuid/getppid/' /usr/bin/vlc > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/bin/vlc
    chmod 755 /usr/bin/vlc
   fi
  fi
 ;;
 exaile_*)
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/lib/exaile/exaile.py  ];then
    bbe -e 's/geteuid/getppid/' /usr/lib/exaile/exaile.py > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/lib/exaile/exaile.py
    chmod 755 /usr/lib/exaile/exaile.py
   fi
  fi
 ;; 
 "0ad"*)
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/games/pyrogenesis  ];then
    bbe -e 's/geteuid/getppid/' /usr/games/pyrogenesis > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/games/pyrogenesis
    chmod 755 /usr/games/pyrogenesis
   fi
  fi
 ;;
 kde-runtime_*)
  if [ -f /usr/bin/kde4 ];then 
    update-mime-database /usr/share/mime
  fi
 ;;
 kde-workspace-bin_*)
  if [ -f /usr/bin/startkde ];then 
    sed -i '19s/.*/alias qdbus=QT_SELECT=qt4 qdbus/' /usr/bin/startkde
  fi
 ;;
 chromium-browser_*)
   if [ -f /usr/bin/chromium-browser ];then
   mv /usr/bin/chromium-browser /usr/bin/chromium-browser1
   echo "#!/bin/sh" > /usr/bin/chromium-browser
   echo 'exec chromium-browser1 --user-data-dir=/root/.config/chrome --allow-outdated-plugins --audio-buffer-size=2048 "$@"
' >> /usr/bin/chromium-browser
   chmod 755 /usr/bin/chromium-browser
   fi
 ;;
 google-earth-stable_*)
   if [ -f /usr/bin/google-earth ];then
   ln -s /lib/ld-2.19.so /lib/ld-lsb-x86-64.so.3
   echo '[Desktop Entry]
Version=1.0
Name=Google Earth
GenericName=3D planet viewer
Comment=Explore, search and discover the planet
Exec=/opt/google/earth/free/google-earth
Terminal=false
MultipleArgs=false
Icon=/opt/google/earth/free/product_logo_128.png
Type=Application
Categories=X-Internet-browser
MimeType=application/vnd.google-earth.kml+xml;application/vnd.google-earth.kmz;application/earthviewer;application/keyhole' > /usr/share/applications/google-earth.desktop
chmod 755 /initrd/pup_rw
   fi
 ;; 
 skype-*)
   if [ -f /usr/bin/skype ];then
   echo '[Desktop Entry]
Name=Skype
Comment=Skype Internet Telephony
Exec=apulse skype
Icon=skype.png
Terminal=false
Type=Application
Encoding=UTF-8
Categories=Network;Application;
MimeType=x-scheme-handler/skype;
X-KDE-Protocols=skype' > /usr/share/applications/skype.desktop
   fi
 ;;
  "iron"*)
   if [ -f /usr/share/iron/iron ];then
   mv /usr/share/iron/iron /usr/share/iron/iron1
   echo "#!/bin/sh" > /usr/share/iron/iron
   echo '/usr/share/iron/iron1 --user-data-dir=/root/.config/chrome --allow-outdated-plugins --audio-buffer-size=2048 "$@"
' >> /usr/share/iron/iron
   chmod 755 /usr/share/iron/iron
   ln -s /usr/share/iron/iron /usr/bin/iron
   fi
 ;;
  python-wxgtk2.8_*)
   if [ -f /usr/lib/python2.7/dist-packages/wx-2.8-gtk2-unicode/wxPython/_wx.py ];then
   ln -s /usr/lib/python2.7/dist-packages/wx-2.8-gtk2-unicode/wx /usr/lib/python2.7/dist-packages
   fi
 ;;
  libwxgtk2.8-dev_*)
   if [ -f /usr/lib/wx/config/gtk2-unicode-release-2.8 ];then
   ln -s /usr/lib/wx/config/gtk2-unicode-release-2.8 /usr/bin/wx-config
   fi
 ;;
  libwxgtk3.0-dev_*)
   if [ -f /usr/lib/wx/config/gtk2-unicode-3.0 ];then
   ln -s /usr/lib/wx/config/gtk2-unicode-3.0 /usr/bin/wx-config
   fi   
 ;;
 "wbar"*)
  if [ -f /usr/bin/wbar ];then
  echo 'i: /usr/share/pixmaps/wbar/dock.png
c: wbar --bpress --above-desk --pos bottom --offset 30 --isize 50 --idist 5 --nanim 4 --falfa 65
t: /usr/share/fonts/default/truetype/droid/DroidSansMono/10

i: /usr/share/pixmaps/wbar/wbar.png
c: wbar-config
t: Config

i: /opt/palemoon/browser/icons/mozicon128.png
c: palemoon
t: Web Browser

i: /usr/share/pixmaps/sylpheed.png
c: sylpheed
t: E-Mail

i: /usr/share/icons/hicolor/48x48/apps/vlc.png
c: vlc
t: Media player

i: /usr/share/icons/hicolor/48x48/apps/geany.png
c: geany
t: Geany

i: /usr/local/lib/X11/themes/Ardis/console48.png
c: urxvt
t: Terminal

i: /usr/local/lib/X11/themes/Ardis/folder48.png
c: rox
t: File Manager' > /root/.wbar
   fi
 ;;
 google-chrome-*) #130221 pemasu. 130224 pemasu: limit cache size...
   if [ -f /opt/google/chrome/chrome  ];then
   mv /opt/google/chrome/google-chrome /opt/google/chrome/google-chrome1
   echo "#!/bin/sh" > /opt/google/chrome/google-chrome
   echo 'export GOOGLE-CHROME=/opt/google/chrome/google-chrome' >> /opt/google/chrome/google-chrome
   echo 'export LD_LIBRARY_PATH=/opt/google/chrome:/opt/google/chrome/lib:$LD_LIBRARY_PATH' >> /opt/google/chrome/google-chrome
   echo 'export CHROME_VERSION_EXTRA="stable"' >> /opt/google/chrome/google-chrome
   echo 'exec /opt/google/chrome/chrome --user-data-dir=/root/.config/chrome --allow-outdated-plugins --audio-buffer-size=2048 "$@"' >> /opt/google/chrome/google-chrome
   chmod 755 /opt/google/chrome/google-chrome
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Google Chrome web browser
GenericName=Google Chrome
Comment=Google Chrome web browser
Exec=google-chrome
Terminal=false
Type=Application
Icon=/opt/google/chrome/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/google-chrome.desktop
ln -s /usr/bin/google-chrome-stable /usr/bin/google-chrome
    bbe -e 's/geteuid/getppid/' /opt/google/chrome/chrome > /tmp/chrome-temp1
    mv -f /tmp/chrome-temp1 /opt/google/chrome/chrome
    chmod 755 /opt/google/chrome/chrome
   echo "#!/bin/sh
cd /
urxvt -e wget http://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
dpkg-deb -x /google-chrome-stable_current_amd64.deb /
rm /google-chrome-stable_current_amd64.deb
rm /opt/google/chrome/google-chrome1
rm /usr/bin/google-chrome-stable
rm /usr/bin/google-chrome
mv /opt/google/chrome/google-chrome /opt/google/chrome/google-chrome1
   echo "#!/bin/sh" > /opt/google/chrome/google-chrome
   echo 'export GOOGLE-CHROME=/opt/google/chrome/google-chrome' >> /opt/google/chrome/google-chrome
   echo 'export LD_LIBRARY_PATH=/opt/google/chrome:/opt/google/chrome/lib:$LD_LIBRARY_PATH' >> /opt/google/chrome/google-chrome
   echo 'export CHROME_VERSION_EXTRA="stable"' >> /opt/google/chrome/google-chrome
   echo 'exec /opt/google/chrome/chrome --user-data-dir=/root/.config/chrome --allow-outdated-plugins --audio-buffer-size=2048 "$@"' >> /opt/google/chrome/google-chrome
   chmod 755 /opt/google/chrome/google-chrome
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Google Chrome web browser
GenericName=Google Chrome
Comment=Google Chrome web browser
Exec=google-chrome
Terminal=false
Type=Application
Icon=/opt/google/chrome/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/google-chrome.desktop
ln -s /opt/google/chrome/google-chrome /usr/bin/google-chrome
    bbe -e 's/geteuid/getppid/' /opt/google/chrome/chrome > /tmp/chrome-temp1
    mv -f /tmp/chrome-temp1 /opt/google/chrome/chrome
    chmod 755 /opt/google/chrome/chrome
chmod 755 /initrd/pup_rw
yaf-splash -bg lightgreen -fg black -placement center -timeout 2 -text chrome_updated" > /usr/bin/google-chrome-updater
chmod 755 /usr/bin/google-chrome-updater
echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Google-Chrome-updater
GenericName=Google-Chrome-updater
Comment=Google-Chrome-updater
Exec=google-chrome-updater
Terminal=false
Type=Application
Icon=/opt/google/chrome/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/google-chrome-updater.desktop
chmod 755 /initrd/pup_rw
   fi
 ;;
vivaldi-*) 
   if [ -f /opt/vivaldi/vivaldi  ];then
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=vivaldi
GenericName=vivaldi
Comment=vivaldi web browser
Exec=vivaldi-stable  --user-data-dir=/root/.config/vivaldi --allow-outdated-plugins --disable-gpu --audio-buffer-size=2048 "$@"
Terminal=false
Type=Application
Icon=/opt/vivaldi/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/vivaldi-stable.desktop
chmod 755 /initrd/pup_rw
   fi
 ;;
opera-*) 
   if [ -f /usr/lib/opera  ];then
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=opera
GenericName=opera
Comment=opera web browser
Exec=opera --disable-gpu
Terminal=false
Type=Application
Icon=/usr/share/icons/hicolor/128x128/apps/opera.png
Categories=WebBrowser;' > /usr/share/applications/opera.desktop
chmod 755 /initrd/pup_rw
   fi
 ;;   
 jwm_theme_*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    sed -i -e 's%DejaVu Sans%Sans%' /etc/xdg/templates/_root_*
    sed -i -e 's%DejaVu Sans%Sans%' /root/.jwm/themes/*-jwmrc
    sed -i -e 's%DejaVu Sans%Sans%' /root/.jwm/jwmrc-theme
   ;;
  esac
  #130326 font size fix for 96 dpi...
  if [ "$INSTALLEDNAME" ];then
   JWMTHEMEFILE="$(grep '^/root/\.jwm/themes/.*-jwmrc$' /root/.packages/${INSTALLEDNAME}.files | head -n 1)"
   [ "$JWMTHEMEFILE" ] && hackfontsize "JWMTHEMES='${JWMTHEMEFILE}'"
  fi
 ;;
 openbox*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    sed -i -e 's%DejaVu Sans%Sans%' /etc/xdg/openbox/*.xml
    sed -i -e 's%DejaVu Sans%Sans%' /root/.config/openbox/*.xml
   ;;
  esac
 ;;
 gtk_theme_*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    GTKRCFILE="$(find /usr/share/themes -type f -name gtkrc | tr '\n' ' ')"
    for ONEGTKRC in $GTKRCFILE
    do
     sed -i -e 's%DejaVu Sans%Sans%' $ONEGTKRC
    done
   ;;
  esac
  #130326 font size fix for 96 dpi...
  if [ "$INSTALLEDNAME" ];then
   GTKTHEMEFILE="$(grep '^/usr/share/themes/.*/gtk-2\.0/gtkrc$' /root/.packages/${INSTALLEDNAME}.files | head -n 1)"
   [ "$GTKTHEMEFILE" ] && hackfontsize "GTKRCS='${GTKTHEMEFILE}'"
  fi
 ;;
 seamonkey*|firefox*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    MOZFILE="$(find /root/.mozilla -type f -name prefs.js -o -name '*.css' | tr '\n' ' ')"
    for ONEMOZ in $MOZFILE
    do
     sed -i -e 's%DejaVu Sans%Sans%' $ONEMOZ
    done
   ;;
  esac
 ;;
 mc_*) #121206 midnight commander
  #in ubuntu, won't run from the menu. this fixes it...
  [ -f /usr/share/applications/mc.desktop ] && sed -i -e 's%^Exec=.*%Exec=TERM=xterm mc%' /usr/share/applications/mc.desktop
 ;;
 xsane*) #130122
  #xsane puts up a warning msg at startup if running as root, remove it...
  #this code is also in file FIXUPHACK in xsane template (in Woof).
  #WARNING: this may only work for x86 binary.
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/bin/xsane  ];then
    bbe -e 's/\x6b\x00getuid/\x6b\x00getpid/' /usr/bin/xsane > /tmp/xsane-temp1
    mv -f /tmp/xsane-temp1 /usr/bin/xsane
    chmod 755 /usr/bin/xsane
   fi
  fi
 ;;
 kompozer*) #130507
  [ -f /usr/bin/kompozer ] && [ -d /usr/lib/kompozer ] && sed -i -e 's%^moz_libdir=%export MOZILLA_FIVE_HOME="/usr/lib/kompozer" #BK\nmoz_libdir=%' /usr/bin/kompozer
 ;;
esac

